import { NextFunction, Request, Response } from 'express';
import { Games } from '../interfaces/games.interface';
import gamesService from '../services/games.service';
import gamesModel from '../models/games.model';
interface MulterRequest extends Request {
  file: any;
}
class GamesController {
  public gamesService = new gamesService();

  public getUnlockGamesByLevel = async (req: Request, res: Response, next: NextFunction) => {
    try {
      const level: string = req.params.level;
      const findAllGamesData: Games[] = await this.gamesService.getUnlockGamesByLevel(level);

      res.status(200).json({ data: findAllGamesData, message: 'findAll' });
    } catch (error) {
      next(error);
    }
  };

  public getLockGamesByLevel = async (req: Request, res: Response, next: NextFunction) => {
    try {
      const level: string = req.params.level;
      const findAllGamesData: Games[] = await this.gamesService.getLockGamesByLevel(level);

      res.status(200).json({ data: findAllGamesData, message: 'findAll' });
    } catch (error) {
      next(error);
    }
  };

  public getGameById = async (req: Request, res: Response, next: NextFunction) => {
    try {
      const id: string = req.params.id;
      const findOneGameData: Games = await this.gamesService.getGameById(id);

      res.status(200).json({ data: findOneGameData, message: 'findOne' });
    } catch (error) {
      next(error);
    }
  };


  public createGame = async (req: MulterRequest, res: Response, next: NextFunction) => {
    try {
       

    const level = req.body.level;
    const number = req.body.number;
    const question = req.body.question;
    const a1 = req.body.a1;
    const a2 = req.body.a2;
    const a3 = req.body.a3;
    const a4 = req.body.a4;
    const correct = req.body.correct;
    const status = req.body.status;
    let video = "https://res.cloudinary.com/dlynw1irw/video/upload/v1710757723/SpeakEzyVideos/09_v5g9hy.mov";
    // if (req.file !== undefined) {      
    //     video = req.file.path
    // }
    let newProduct = new gamesModel({
        level, number, question, a1, a2, a3, a4, correct,video, status
  })

     const createGameData: Games = await this.gamesService.createGame(newProduct);

      res.status(201).json({ data: createGameData, message: 'created' });
    } catch (error) {
      next(error);
    }
  };


  public deleteGame = async (req: Request, res: Response, next: NextFunction) => {
    try {
      const id: string = req.params.id;
      const deleteGameData: Games = await this.gamesService.deleteGame(id);

      res.status(200).json({ data: deleteGameData, message: 'deleted' });
    } catch (error) {
      next(error);
    }
  };
}

export default GamesController;
