import { NextFunction, Request, Response } from 'express';
import { Users } from '../interfaces/users.interface';
import usersService from '../services/users.service';
import usersModel from '../models/users.model';

class UsersController {
  public usersService = new usersService();

  public findUsersById = async (req: Request, res: Response, next: NextFunction) => {
    try {
      const userId: string = req.params.id;
      const findOneUserData: Users = await this.usersService.findUsersById(userId);

      res.status(200).json({ data: findOneUserData, message: 'findOne' });
    } catch (error) {
      next(error);
    }
  };

  public findUsersByEmailAndPassword = async (req: Request, res: Response, next: NextFunction) => {
    try {
      const email: string = req.body.email;
      const password: string = req.body.password;
      console.log(email)
      console.log(password)
      const findUserData: Users = await this.usersService.findUsersByEmailAndPassword(email,password);

      if(findUserData){
        res.status(200).json({ data: findUserData, message: 'true' });
      }else{
        res.status(200).json({ data: findUserData, message: 'false' });
      }
      
    } catch (error) {
      next(error);
    }
  };


  public createUsers = async (req: Request, res: Response, next: NextFunction) => {
    try {
    const name = req.body.name;
    const email = req.body.email;
    const dob = req.body.dob;
    const gender = req.body.gender;
    const phone = req.body.phone;
    const password = req.body.password;
    const intermediateGameLevel = 1;
    const advancedGameLevel = 1;
    const gameScore = 0;
    const learnScore = 0;
    const status = "A";

    let newUser = new usersModel({
        name, email, dob, gender, phone, password, intermediateGameLevel, advancedGameLevel, gameScore, learnScore, status
  })

      const createUserData: Users = await this.usersService.createUsers(newUser);

      res.status(201).json({ data: createUserData, message: 'created' });
    } catch (error) {
      next(error);
    }
  };




}

export default UsersController;
