import { model, Schema, Document } from 'mongoose';
import { Games } from '../interfaces/games.interface';

const gamesSchema: Schema = new Schema({
    level: {
        type: String,
        required: true,
        unique: false
    },
    number: {
        type: String,
        required: true,
        unique: false
    },
    question: {
        type: String,
        required: true,
        unique: false
    },
    a1: {
        type: String,
        required: true,
        unique: false
    },
    a2: {
        type: String,
        required: true,
        unique: false
    },
    a3: {
        type: String,
        required: true,
        unique: false
    },
    a4: {
        type: String,
        required: true,
        unique: false
    },
    correct: {
        type: String,
        required: true,
        unique: false
    },
    video: {
        type: String,
        required: true,
        unique: false
    },
    status: {
        type: String,
        required: true,
        unique: false
    }
});

const gamesModel = model<Games & Document>('Games', gamesSchema);

export default gamesModel;
