import { model, Schema, Document } from 'mongoose';
import { Items } from '../interfaces/items.interface';

const itemsSchema: Schema = new Schema({
    resourcesId: {
        type: String,
        required: true,
        unique: false
    },
    topic: {
        type: String,
        required: true,
        unique: false
    },
    details: {
        type: String,
        required: true,
        unique: false
    },
    image: {
        type: String,
        required: false,
        unique: false
    },
    label: {
        type: String,
        required: true,
        unique: false
    }
});

const itemsModel = model<Items & Document>('Items', itemsSchema);

export default itemsModel;
