import { model, Schema, Document } from 'mongoose';
import { Users } from '../interfaces/users.interface';

const usersSchema: Schema = new Schema({
    name: {
        type: String,
        required: true,
        unique: false
    },
    email: {
        type: String,
        required: true,
        unique: false
    },
    dob: {
        type: String,
        required: true,
        unique: false
    },
    gender: {
        type: String,
        required: true,
        unique: false
    },
    password: {
        type: String,
        required: true,
        unique: false
    },
    phone: {
        type: String,
        required: true,
        unique: false
    },
    intermediateGameLevel: {
        type: Number,
        required: true,
        unique: false
    },
    advancedGameLevel: {
        type: Number,
        required: true,
        unique: false
    },
    gameScore: {
        type: Number,
        required: true,
        unique: false
    },
    learnScore: {
        type: Number,
        required: true,
        unique: false
    },
    status: {
        type: String,
        required: true,
        unique: false
    }
});

const usersModel = model<Users & Document>('Users', usersSchema);

export default usersModel;
