import { Router } from 'express';
import gamesController from '../controllers/games.controller';
import { Routes } from '../interfaces/routes.interface';




class GamesRoute implements Routes {
  public path = '/games';
  public router = Router();
  public gamesController = new gamesController();

  constructor() {
    this.initializeRoutes();
  }

  private initializeRoutes() {
    this.router.get(`${this.path}//:level`, this.gamesController.getUnlockGamesByLevel);
    this.router.get(`${this.path}///:level`, this.gamesController.getLockGamesByLevel);
    this.router.get(`${this.path}/:id`, this.gamesController.getGameById);
    this.router.post(`${this.path}`,  this.gamesController.createGame);
    this.router.delete(`${this.path}/:id`, this.gamesController.deleteGame);
  }
}

export default GamesRoute;
