import { Router } from 'express';
import usersController from '../controllers/users.controller';
import { CreateUsersDto } from '../dtos/users.dto';
import { Routes } from '../interfaces/routes.interface';
import validationMiddleware from '../middlewares/validation.middleware';

class CategoryRoute implements Routes {
  public path = '/users';
  public router = Router();
  public usersController = new usersController();

  constructor() {
    this.initializeRoutes();
  }

  private initializeRoutes() {
    this.router.get(`${this.path}`, this.usersController.findUsersById);
    this.router.post(`${this.path}/login`, this.usersController.findUsersByEmailAndPassword);
    this.router.post(`${this.path}`,  this.usersController.createUsers);
  }
}

export default CategoryRoute;
