import { HttpException } from '../exceptions/HttpException';
import { Users } from '@/interfaces/users.interface';
import usersModel from '../models/users.model';
import { isEmpty } from '../utils/util';

class UsersService {

  public users = usersModel;


  public async findUsersById(userId: string): Promise<Users> {
    if (isEmpty(userId)) throw new HttpException(400, "expenseId is empty");

    const findUser: Users = await this.users.findOne({ _id: userId });
    if (!findUser) throw new HttpException(409, "Expense doesn't exist");

    return findUser;
  }

  public async findUsersByEmailAndPassword(email: string, password: string): Promise<Users> {
    console.log(email)
    console.log(password)
    const findUser: Users = await this.users.findOne({ email: email, password:password});
    return findUser;
  }

  public async createUsers(usersData: Users): Promise<Users> {
    if (isEmpty(usersData)) throw new HttpException(400, "expenseData is empty");
    const createUsersData: Users = await this.users.create(usersData);
    return createUsersData;
  }

 
}

export default UsersService;
